﻿Public Class CalculatorForm
    ' class level variables/constants
    Const TAX_RATE_DECIMAL As Decimal = 0.075
    Const CAPPUCCINO_RATE_DECIMAL As Decimal = 3.25
    Const ESPRESSO_RATE_DECIMAL As Decimal = 3.4
    Const LATTE_RATE_DECIMAL As Decimal = 2.75
    Const ICED_LATTE_RATE_DECIMAL As Decimal = 3.15
    Const ICED_CAPPUCCINO_RATE_DECIMAL As Decimal = 3


    Private Sub ExitButton_Click(sender As Object, e As EventArgs) Handles ExitButton.Click
        ' exit the application
        Application.Exit()
    End Sub

    Private Sub CalculateButton_Click(sender As Object, e As EventArgs) Handles CalculateButton.Click
        Dim QuantityInteger As Integer
        Dim AmountDecimal, TotalAmountDecimal As Decimal

        Try
            QuantityInteger = Integer.Parse(QuantityTextBox.Text)

            If QuantityInteger > 0 Then
                ' valid quantity

                ' find rate of selected coffee
                If CappuccinoRadioButton.Checked Then
                    AmountDecimal = CAPPUCCINO_RATE_DECIMAL
                ElseIf EspressoRadioButton.Checked Then
                    AmountDecimal = ESPRESSO_RATE_DECIMAL
                ElseIf LatteRadioButton.Checked Then
                    AmountDecimal = LATTE_RATE_DECIMAL
                ElseIf IcedLatteRadioButton.Checked Then
                    AmountDecimal = ICED_LATTE_RATE_DECIMAL
                Else
                    AmountDecimal = ICED_CAPPUCCINO_RATE_DECIMAL
                End If

                ' calculate total
                TotalAmountDecimal = AmountDecimal * QuantityInteger

                ' determine if takeout (no tax)
                If Not TakeoutCheckBox.Checked Then
                    ' not takeout/must be dine in, charge sales tax
                    TotalAmountDecimal += TotalAmountDecimal * TAX_RATE_DECIMAL
                End If

                ' output results 
                ItemAmountTextBox.Text = TotalAmountDecimal.ToString("c")


            Else
                ' invalid quantity
                ' display error
                MessageBox.Show("You must enter a quantity > 0.",
                                "Data Entry Error",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Error)
                ' reset input
                QuantityTextBox.Focus()
                QuantityTextBox.SelectAll()
            End If

        Catch QuantityException As FormatException
            ' display error
            MessageBox.Show("You must enter a numeric quantity.",
                            "Data Entry Error",
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Error)
            ' reset input
            QuantityTextBox.Focus()
            QuantityTextBox.SelectAll()
        End Try
    End Sub
End Class
